# coding: utf-8

"""
    Google Drive API

    The Google Drive API allows clients to access resources from Google Drive.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_drive_ti.models.change import Change
from typing import Optional, Set
from typing_extensions import Self

class ChangeList(BaseModel):
    """
    A list of changes for a user.
    """ # noqa: E501
    changes: Optional[List[Change]] = Field(default=None, description="The list of changes. If nextPageToken is populated, then this list may be incomplete and an additional page of results should be fetched.")
    kind: Optional[StrictStr] = Field(default='drive#changeList', description="Identifies what kind of resource this is. Value: the fixed string `\"drive#changeList\"`.")
    new_start_page_token: Optional[StrictStr] = Field(default=None, description="The starting page token for future changes. This will be present only if the end of the current changes list has been reached. The page token doesn't expire.", alias="newStartPageToken")
    next_page_token: Optional[StrictStr] = Field(default=None, description="The page token for the next page of changes. This will be absent if the end of the changes list has been reached. The page token doesn't expire.", alias="nextPageToken")
    __properties: ClassVar[List[str]] = ["changes", "kind", "newStartPageToken", "nextPageToken"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChangeList from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in changes (list)
        _items = []
        if self.changes:
            for _item_changes in self.changes:
                if _item_changes:
                    _items.append(_item_changes.to_dict())
            _dict['changes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChangeList from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "changes": [Change.from_dict(_item) for _item in obj["changes"]] if obj.get("changes") is not None else None,
            "kind": obj.get("kind") if obj.get("kind") is not None else 'drive#changeList',
            "newStartPageToken": obj.get("newStartPageToken"),
            "nextPageToken": obj.get("nextPageToken")
        })
        return _obj


