# coding: utf-8

"""
    Google Drive API

    The Google Drive API allows clients to access resources from Google Drive.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_drive_ti.models.label_field_modification import LabelFieldModification
from typing import Optional, Set
from typing_extensions import Self

class LabelModification(BaseModel):
    """
    A modification to a label on a file. A LabelModification can be used to apply a label to a file, update an existing label on a file, or remove a label from a file.
    """ # noqa: E501
    field_modifications: Optional[List[LabelFieldModification]] = Field(default=None, description="The list of modifications to this label's fields.", alias="fieldModifications")
    kind: Optional[StrictStr] = Field(default=None, description="This is always drive#labelModification.")
    label_id: Optional[StrictStr] = Field(default=None, description="The ID of the label to modify.", alias="labelId")
    remove_label: Optional[StrictBool] = Field(default=None, description="If true, the label will be removed from the file.", alias="removeLabel")
    __properties: ClassVar[List[str]] = ["fieldModifications", "kind", "labelId", "removeLabel"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LabelModification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in field_modifications (list)
        _items = []
        if self.field_modifications:
            for _item_field_modifications in self.field_modifications:
                if _item_field_modifications:
                    _items.append(_item_field_modifications.to_dict())
            _dict['fieldModifications'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LabelModification from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fieldModifications": [LabelFieldModification.from_dict(_item) for _item in obj["fieldModifications"]] if obj.get("fieldModifications") is not None else None,
            "kind": obj.get("kind"),
            "labelId": obj.get("labelId"),
            "removeLabel": obj.get("removeLabel")
        })
        return _obj


