# coding: utf-8

"""
    Google Drive API

    The Google Drive API allows clients to access resources from Google Drive.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_drive_ti.models.access_proposal import AccessProposal
from typing import Optional, Set
from typing_extensions import Self

class ListAccessProposalsResponse(BaseModel):
    """
    The response to an Access Proposal list request.
    """ # noqa: E501
    access_proposals: Optional[List[AccessProposal]] = Field(default=None, description="The list of Access Proposals. This field is only populated in v3 and v3beta.", alias="accessProposals")
    next_page_token: Optional[StrictStr] = Field(default=None, description="The continuation token for the next page of results. This will be absent if the end of the results list has been reached. If the token is rejected for any reason, it should be discarded, and pagination should be restarted from the first page of results.", alias="nextPageToken")
    __properties: ClassVar[List[str]] = ["accessProposals", "nextPageToken"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListAccessProposalsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in access_proposals (list)
        _items = []
        if self.access_proposals:
            for _item_access_proposals in self.access_proposals:
                if _item_access_proposals:
                    _items.append(_item_access_proposals.to_dict())
            _dict['accessProposals'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListAccessProposalsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accessProposals": [AccessProposal.from_dict(_item) for _item in obj["accessProposals"]] if obj.get("accessProposals") is not None else None,
            "nextPageToken": obj.get("nextPageToken")
        })
        return _obj


